/** 


Este  o verdadeiro servidor de citaes. Ao contrrio do programa cliente/servidor
antigo, orientado a stream de dados e SOCKET, este utiliza o conceito de DATAGRAMAS.
No caso de sockets, uma conexo  estabelecida e os dados enviados ordenadamente
de um lado para outro. O canal ponto-a-ponto garante isso.
Por um outro lado, ao usarmos datagramas, a comunicacao se d por meio de
envio de PACOTES de dados independentes! Nao h canal ponto-a-ponto e
nada garante que os pacotes serao enviados (send) ou recebidos (receive), ou
mesmo se chegaro na ordem em que foram enviados. As classes de java
disponveis para isso sao UDP...


*/

import java.io.*;
import java.net.*;
import java.util.*;

public class QuoteServerThread extends Thread {

    protected DatagramSocket socket = null;
    protected BufferedReader in = null;
    protected boolean moreQuotes = true;

//    public QuoteServerThread() throws IOException {
//	this("QuoteServerThread");
//    }

    public QuoteServerThread() throws IOException {
        //super(name);
        socket = new DatagramSocket(4445);

        try {
            // A fonte de leitura  um arquivo texto de citaes...
            in = new BufferedReader(new FileReader("citacoes.txt"));
        } catch (FileNotFoundException e) {
            System.err.println("Arquivo de citacoes nao encontrado. S posso enviar a data.");
        }
    }

    public void run() {

        while (moreQuotes) {
            try {
                byte[] buf = new byte[256];

                // Cria um datagrama de 256 bytes..
                DatagramPacket packet = new DatagramPacket(buf, buf.length);
		// recebe o pedido. PRIMITIVA BLOQUEANTE.
		// enquanto nao receber, espera.....
                socket.receive(packet);
                System.out.println("enviei...");
		
                // "Calcula" a resposta. Se nao achou o arquivo de citacoes, 
		// envia a data atual para o cliente
                String dString = null;
                if (in == null)
                    dString = new Date().toString();
                else
	            // O arquivo existe. Retorna uma citao...
                    dString = getNextQuote();
                buf = dString.getBytes();

		
		// Pega o endereco (IP) e a port que o cliente mandou .
		// Isto est no datagrama que o cliente mandou !!!!!!!!
                InetAddress address = packet.getAddress();
                int port = packet.getPort();
		// Cria o pacote contendo as informacoes destino)
                packet = new DatagramPacket(buf, buf.length, address, port);
		// Envia o pacote para o cliente
                socket.send(packet);
            } catch (IOException e) {
                e.printStackTrace();
		moreQuotes = false;
            }
        }
        socket.close();
    }

    // Pega citacao, uma a uma do arquivo at acabar..
    protected String getNextQuote() {
        String returnValue = null;
        try {
            if ((returnValue = in.readLine()) == null) {
                in.close();
		moreQuotes = false;
                returnValue = "No more quotes. Goodbye.";
            }
        } catch (IOException e) {
            returnValue = "IOException occurred in server.";
        }
        return returnValue;
    }
}
